`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    15:47:59 01/06/06
// Design Name:    
// Module Name:    CONV_GEN
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module CONV_GEN(	DDC_CLK,	
						FPGA_RESET,
						CONV_LOW_REG,
						CONV_HIGH_REG,
						CONV_OUT,
						CONV_SEL
						);

input DDC_CLK;
input FPGA_RESET;
input [17:0] CONV_LOW_REG;
input [17:0] CONV_HIGH_REG;
output CONV_OUT;
wire CONV_OUT;
input [1:0] CONV_SEL;

reg [17:0] conv_count_low;
reg [17:0] conv_count_high;
reg oscillating_conv;

always @(posedge DDC_CLK or negedge FPGA_RESET)
  begin

  if(FPGA_RESET==1'b0)
    begin
	 conv_count_low[17:0]=18'b00_0000_0000__0000_0000;
	 conv_count_high[17:0]=18'b00_0000_0000__0000_0000;
	 oscillating_conv=1'b0;
	 end

  else
    begin
	 case( {oscillating_conv, {|conv_count_low[17:0],|conv_count_high[17:0]} } )
	   3'b010:
			begin
				oscillating_conv=1'b0;
				conv_count_low[17:0] = conv_count_low[17:0] - 18'b00__0000_0000__0000_0001;
			end
	   3'b011:
			begin
				oscillating_conv=1'b0;
				conv_count_low[17:0] = conv_count_low[17:0] - 18'b00__0000_0000__0000_0001;
			end

	   3'b000:
			begin
				oscillating_conv=1'b1;
				conv_count_low[17:0] = CONV_LOW_REG[17:0];
			end
		3'b001:
			begin
				oscillating_conv=1'b1;
				conv_count_low[17:0] = CONV_LOW_REG[17:0];
			end

		3'b101:
			begin
				oscillating_conv=1'b1;
				conv_count_high[17:0] = conv_count_high[17:0] - 18'b00__0000_0000__0000_0001;
			end
		3'b111:
			begin
				oscillating_conv=1'b1;
				conv_count_high[17:0] = conv_count_high[17:0] - 18'b00__0000_0000__0000_0001;
			end

		3'b100:
			begin
				oscillating_conv=1'b0;
				conv_count_high[17:0] = CONV_HIGH_REG[17:0];
			end
		3'b110:
			begin
				oscillating_conv=1'b0;
				conv_count_high[17:0] = CONV_HIGH_REG[17:0];
			end

	   default:
		   begin
				oscillating_conv=1'b1;
				conv_count_high[17:0] = conv_count_high[17:0] - 18'b00__0000_0000__0000_0001;
			end
	 endcase

//	 if(!oscillating_conv & |conv_count_low[17:0])  //01
//	   begin
//		oscillating_conv=1'b0;
//		conv_count_low[17:0] = conv_count_low[17:0] - 18'b00__0000_0000__0000_0001;
//		end
//	 else if(!oscillating_conv & !(|conv_count_low[17:0]))	 //00
//	   begin
//		oscillating_conv=1'b1;
//		conv_count_low[17:0] = CONV_LOW_REG[17:0];
//		end
//	 else if(oscillating_conv && |conv_count_high[17:0])	 //11
//	   begin
//		oscillating_conv=1'b1;
//		conv_count_high[17:0] = conv_count_high[17:0] - 18'b00__0000_0000__0000_0001;
//		end
//	 else	//if(oscillating_conv && !(|conv_count_high[17:0]))	 //10
//	   begin
//		oscillating_conv=1'b0;
//		conv_count_high[17:0] = CONV_HIGH_REG[17:0];
//		end
	 end

  end

assign CONV_OUT = (CONV_SEL[1]==1'b0) ? oscillating_conv : (CONV_SEL[0]==1'b0) ? 1'b0 : 1'b1;
						//CONV SEL [ manual control bit (if 1, then manual control) : manual state ]

endmodule
