`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    10:47:18 01/27/06
// Design Name:    
// Module Name:    DDC_DATA_CAP
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module DDC_DATA_CAP(	FPGA_CLK,
							FPGA_RESET,
							DOUT_IN,
							CAP_DATA_OUT,
							BITS_TO_READ,
							FORMAT,
							DATA_READY,
							ACK,
							READ_ONE_DATA_SET_FROM_DDC,
							DONE_READING_DATA_SET_FROM_DDC,
							DCLK_OUT,
							DIVXCLK_LOW_REG,
							DIVXCLK_HIGH_REG,
							DCLK_WAIT_COUNT,
							DXMIT
							);							

input FPGA_CLK;
input FPGA_RESET;
input DOUT_IN;
output [19:0] CAP_DATA_OUT;
wire [19:0] CAP_DATA_OUT;
input [14:0] BITS_TO_READ;
input FORMAT;
output DATA_READY;
reg DATA_READY;
input ACK;
input READ_ONE_DATA_SET_FROM_DDC;		  //////this is where I left off working 2/3/06  I need to trigger a bit_to_read parallel load then decr.
output DONE_READING_DATA_SET_FROM_DDC;
reg DONE_READING_DATA_SET_FROM_DDC;

output DCLK_OUT;
wire DCLK_OUT;
input [3:0] DIVXCLK_LOW_REG;
input [3:0] DIVXCLK_HIGH_REG;
input [15:0] DCLK_WAIT_COUNT;
output DXMIT;
reg DXMIT;



reg load_bigcount_i;
reg decr_bigcount_i;
reg load_count_i;
reg decr_count_i;
reg done_reading_data_set_from_ddc_i;
reg read_bit_i;
reg toggle_cap_sel;
reg [14:0] bigcount;
reg [4:0] count;
reg [2:0] FSMn, FSM;
reg [19:0] cap_data_out_0;
reg [19:0] cap_data_out_1;
reg cap_sel;
reg data_ready_i;
reg reset_divxclk_low_count_i;
reg reset_divxclk_high_count_i;
reg decr_divxclk_low_count_i;
reg decr_divxclk_high_count_i;
reg reset_dclk_wait_i;
reg decr_dclk_wait_i;

reg dclk_i, dclk_out_reg;
reg [3:0] divXclk_count_low;
reg [3:0] divXclk_count_high;
reg [15:0] dclk_wait_count_reg;
reg dxmit_i;


parameter	IDLE = 3'b000,
				DCLK_WAIT_STATE = 3'b001,
				DCLK_HIGH_STATE = 3'b010,
				DCLK_LOW_STATE = 3'b011,
				WAIT_FOR_ACK_FROM_FIFO = 3'b100,
				ADD_ONE_DCLK = 3'b101,
				DONE_STATE = 3'b110;


assign CAP_DATA_OUT[19:0]=(cap_sel==1'b0)?cap_data_out_1[19:0]:cap_data_out_0[19:0];
assign DCLK_OUT = dclk_out_reg;

always @(posedge FPGA_CLK or negedge FPGA_RESET)
	begin
		if(FPGA_RESET==1'b0)
			begin
				FSM=IDLE;
				bigcount[14:0]=15'b000_0000__0000_0000;
				count[4:0]=5'b00000;

				divXclk_count_low[3:0] = 4'h2;
				divXclk_count_high[3:0] = 4'h2;						  
				dclk_wait_count_reg[15:0]=16'h0000;
				
				DATA_READY=1'b0;
				DONE_READING_DATA_SET_FROM_DDC=1'b0;
				dclk_out_reg=1'b0;
				DXMIT = 1'b1;

				cap_sel=1'b0;
				cap_data_out_0[19:0]=20'h00000;
				cap_data_out_1[19:0]=20'h00000;
			end
		else
			begin
				FSM=FSMn;
				if(load_bigcount_i==1'b1)              bigcount[14:0] = BITS_TO_READ[14:0];
				if(decr_bigcount_i==1'b1)              bigcount[14:0] = bigcount[14:0] -15'h0001;
				if(load_count_i==1'b1 && FORMAT==1'b1)     count[4:0] = 5'b10100;
				if(load_count_i==1'b1 && FORMAT==1'b0)     count[4:0] = 5'b10000;
				if(decr_count_i==1'b1)                     count[4:0] = count[4:0] -5'h01;

				if(reset_divxclk_low_count_i==1'b1)     divXclk_count_low[3:0] = DIVXCLK_LOW_REG[3:0];
				if(reset_divxclk_high_count_i==1'b1)   divXclk_count_high[3:0] = DIVXCLK_HIGH_REG[3:0];
				if(reset_dclk_wait_i==1'b1)          dclk_wait_count_reg[15:0] = DCLK_WAIT_COUNT[15:0];

				if(decr_divxclk_low_count_i==1'b1)    divXclk_count_low[3:0] = divXclk_count_low[3:0]-4'h1;
				if(decr_divxclk_high_count_i==1'b1)  divXclk_count_high[3:0] = divXclk_count_high[3:0]-4'h1;
				if(decr_dclk_wait_i==1'b1)         dclk_wait_count_reg[15:0] = dclk_wait_count_reg[15:0]-16'h0001;

				DATA_READY = data_ready_i;
				DONE_READING_DATA_SET_FROM_DDC = done_reading_data_set_from_ddc_i;
				dclk_out_reg = dclk_i;
				DXMIT = dxmit_i;
	  
				if(toggle_cap_sel==1'b1)                           cap_sel = ~cap_sel;
				if(read_bit_i==1'b1 && cap_sel==1'b0) cap_data_out_0[19:0] = {cap_data_out_0[18:0],DOUT_IN};
				if(read_bit_i==1'b1 && cap_sel==1'b1) cap_data_out_1[19:0] = {cap_data_out_1[18:0],DOUT_IN};
			end
	end
 
always @(  FSM or
           bigcount or
           count or
			  divXclk_count_low or
			  divXclk_count_high or
			  dclk_wait_count_reg or
           READ_ONE_DATA_SET_FROM_DDC or
           ACK
           )
	begin
		FSMn=FSM;

		load_bigcount_i=1'b0;
		decr_bigcount_i=1'b0;
		load_count_i=1'b0;
		decr_count_i=1'b0;

		read_bit_i=1'b0;

		toggle_cap_sel=1'b0;
		data_ready_i=1'b0;
		done_reading_data_set_from_ddc_i=1'b0;

		reset_divxclk_low_count_i=1'b0;
		reset_divxclk_high_count_i=1'b0;
		reset_dclk_wait_i=1'b0;

		decr_divxclk_low_count_i=1'b0;
		decr_divxclk_high_count_i=1'b0;
		decr_dclk_wait_i=1'b0; 

		dclk_i=1'b0;
		dxmit_i=1'b1;
       
		case(FSM)
			IDLE:
				begin
					if(READ_ONE_DATA_SET_FROM_DDC==1'b1)
						begin
							FSMn=DCLK_WAIT_STATE;
							load_bigcount_i=1'b1;
							load_count_i=1'b1;	
							reset_dclk_wait_i=1'b1;
							dxmit_i=1'b0;
						end
					else
						begin
							FSMn=IDLE;
						end
				end
        
			DCLK_WAIT_STATE:
				begin
					dxmit_i=1'b0;
					if(|dclk_wait_count_reg[15:0]==1'b0)
					   begin
							FSMn=DCLK_HIGH_STATE;
							reset_divxclk_high_count_i=1'b1;
							dclk_i=1'b1;
						end
					else
						begin
							FSMn=DCLK_WAIT_STATE;
							decr_dclk_wait_i=1'b1;
						end
				end
			
			DCLK_HIGH_STATE:
				begin
					dxmit_i=1'b0;
					if(|divXclk_count_high[3:0]==1'b0)
					   begin
							FSMn=DCLK_LOW_STATE;
						   read_bit_i=1'b1;
						   decr_count_i=1'b1;
						   decr_bigcount_i=1'b1;
							reset_divxclk_low_count_i=1'b1;
						end
					else
						begin
							FSMn=DCLK_HIGH_STATE;
							dclk_i=1'b1;
							decr_divxclk_high_count_i=1'b1;
						end
				end
			
			DCLK_LOW_STATE:
				begin
					dxmit_i=1'b0;
					if(|divXclk_count_low[3:0]==1'b0)
					   begin
							if(|count[4:0]==1'b1)
								begin
									FSMn=DCLK_HIGH_STATE;
									dclk_i=1'b1;
									reset_divxclk_high_count_i=1'b1;
								end
							else
								begin
									FSMn=WAIT_FOR_ACK_FROM_FIFO;
									data_ready_i=1'b1;
        			      	   toggle_cap_sel=1'b1;
								end
						end
					else
						begin
							FSMn=DCLK_LOW_STATE;
							decr_divxclk_low_count_i=1'b1;
						end
				end
        
			WAIT_FOR_ACK_FROM_FIFO:
				begin
					data_ready_i=1'b1;
					dxmit_i=1'b0;
					if(ACK==1'b1)
						begin
							if(|bigcount[14:0]==1'b1)  //done with channel, not done with all channels
								begin
									FSMn=DCLK_HIGH_STATE;
									dclk_i=1'b1;
									reset_divxclk_high_count_i=1'b1;
									load_count_i=1'b1;
								end
							else //bigcount=0, all done reading all channels, get outta here.
								begin
									FSMn=DONE_STATE;
								end
						end
				end
     
        
			DONE_STATE:
				begin
					if(READ_ONE_DATA_SET_FROM_DDC==1'b1)
						begin
							FSMn=DONE_STATE;
							done_reading_data_set_from_ddc_i=1'b1;
						end
					else
						begin
							FSMn=IDLE;
						end
				end

			default:
				begin
					FSMn=IDLE;
				end

       endcase        
    end

endmodule




































module DDC_DATA_CAP_old(	DDC_DATA_CLK,
							FPGA_RESET,
							DCLK_EN,
							DOUT_IN,
							CAP_DATA_OUT,
							BITS_TO_READ,
							FORMAT,
							DATA_READY,
							ACK,
							READ_ONE_DATA_SET_FROM_DDC,
							DONE_READING_DATA_SET_FROM_DDC
							);							

input DDC_DATA_CLK;
input FPGA_RESET;
output DCLK_EN;
reg DCLK_EN;
input DOUT_IN;
output [19:0] CAP_DATA_OUT;
wire [19:0] CAP_DATA_OUT;
input [14:0] BITS_TO_READ;
input FORMAT;
output DATA_READY;
reg DATA_READY;
input ACK;
input READ_ONE_DATA_SET_FROM_DDC;		  //////this is where I left off working 2/3/06  I need to trigger a bit_to_read parallel load then decr.
output DONE_READING_DATA_SET_FROM_DDC;
reg DONE_READING_DATA_SET_FROM_DDC;

reg load_bigcount_i;
reg decr_bigcount_i;
reg load_count_i;
reg decr_count_i;
reg done_reading_data_set_from_ddc_i;
reg read_on_posedge_i, read_on_posedge_p;
reg toggle_cap_sel;
reg [14:0] bigcount;
reg [4:0] count;
reg [2:0] FSMn, FSM;
reg [19:0] cap_data_out_0;
reg [19:0] cap_data_out_1;
reg cap_sel;
reg data_ready_i;
reg dclk_en_i;

parameter	IDLE = 3'b000,
				SETUP_FOR_CAPTURE = 3'b001,
				READ_FIRST_DATA_BIT = 3'b010,
				READ_MORE_DATA_BITS = 3'b011,
				WAIT_FOR_ACK_FROM_FIFO = 3'b100,
				ADD_ONE_DCLK = 3'b101,
				DONE_STATE = 3'b110;


assign CAP_DATA_OUT[19:0]=(cap_sel==1'b0)?cap_data_out_1[19:0]:cap_data_out_0[19:0];

always @(posedge DDC_DATA_CLK or negedge FPGA_RESET)
   begin
      if(FPGA_RESET==1'b0)
        begin
           cap_data_out_0[19:0]=20'h00000;
           cap_data_out_1[19:0]=20'h00000;
	     end
      else
        begin
           if(read_on_posedge_p==1'b1 && cap_sel==1'b0) cap_data_out_0[19:0]={cap_data_out_0[18:0],DOUT_IN};
           if(read_on_posedge_p==1'b1 && cap_sel==1'b1) cap_data_out_1[19:0]={cap_data_out_1[18:0],DOUT_IN};
	     end
	end



always @(negedge DDC_DATA_CLK or negedge FPGA_RESET)
   begin
      if(FPGA_RESET==1'b0)
        begin
	 	    FSM=IDLE;
	 	    bigcount[14:0]=15'b000_0000__0000_0000;
	       count[4:0]=5'b00000;
		    DATA_READY=1'b0;
		    DONE_READING_DATA_SET_FROM_DDC=1'b0;
		    read_on_posedge_p=1'b0;
		    cap_sel=1'b0;
		    DCLK_EN=1'b0;
	     end
      else
        begin
	 	    FSM=FSMn;
	       if(load_bigcount_i==1'b1) bigcount[14:0] = BITS_TO_READ[14:0];
		    if(decr_bigcount_i==1'b1) bigcount[14:0] = bigcount[14:0] -15'b000_0000__0000_0001;
		    if(load_count_i==1'b1 && FORMAT==1'b1) count[4:0] = 5'b10011;
		    if(load_count_i==1'b1 && FORMAT==1'b0) count[4:0] = 5'b01111;
		    if(decr_count_i==1'b1) count[4:0] = count[4:0] -5'b00001;
		    DONE_READING_DATA_SET_FROM_DDC = done_reading_data_set_from_ddc_i;
		    read_on_posedge_p=read_on_posedge_i;
		    if(toggle_cap_sel==1'b1) cap_sel=~cap_sel;
		    DATA_READY=data_ready_i;
		    DCLK_EN=dclk_en_i;
	     end
	end
 
always @(  FSM or
           bigcount or
           count or
           READ_ONE_DATA_SET_FROM_DDC or
           ACK
           )
    begin
       FSMn=FSM;
       load_bigcount_i=1'b0;
       decr_bigcount_i=1'b0;
       load_count_i=1'b0;
       decr_count_i=1'b0;
       done_reading_data_set_from_ddc_i=1'b0;
       read_on_posedge_i=1'b0;
       toggle_cap_sel=1'b0;
       data_ready_i=1'b0;
       dclk_en_i=1'b0;
       
       case(FSM)
           IDLE:
           begin
               if(READ_ONE_DATA_SET_FROM_DDC==1'b1)
                  begin
                      FSMn=SETUP_FOR_CAPTURE;
                  end
               else
                  begin
                      FSMn=IDLE;
                  end
           end
           
           SETUP_FOR_CAPTURE:
           begin
               FSMn=READ_FIRST_DATA_BIT;
               load_bigcount_i=1'b1;
               load_count_i=1'b1;
               read_on_posedge_i=1'b1;
               dclk_en_i=1'b1;
           end
           
           READ_FIRST_DATA_BIT:
           begin
               FSMn=READ_MORE_DATA_BITS;
               dclk_en_i=1'b1;
               read_on_posedge_i=1'b1;
               decr_count_i=1'b1;
               decr_bigcount_i=1'b1;
           end
           
           READ_MORE_DATA_BITS:
           begin
               if(|count[4:0]==1'b1)
               begin
                   FSMn=READ_MORE_DATA_BITS;
                   dclk_en_i=1'b1;
                   read_on_posedge_i=1'b1;
                   decr_count_i=1'b1;
                   decr_bigcount_i=1'b1;
               end
               else
               begin
                   data_ready_i=1'b1;
                   toggle_cap_sel=1'b1;
                   FSMn=WAIT_FOR_ACK_FROM_FIFO;
               end
           end
           
           WAIT_FOR_ACK_FROM_FIFO:
           begin
               data_ready_i=1'b1;
               if(ACK==1'b1)
               begin
                   if(|bigcount[14:0]==1'b1)  //done with channel, not done with all channels
                   begin
                       FSMn=READ_FIRST_DATA_BIT;
                       dclk_en_i=1'b1;
                       load_count_i=1'b1;
                       decr_bigcount_i=1'b1;
                       read_on_posedge_i=1'b1;
                   end
                   else //bigcount=0, all done reading all channels, get outta here.
                   begin
                       FSMn=DONE_STATE;
                   end
               end
           end
           
           /* ADD_ONE_DCLK:
           begin
               FSMn=READ_FIRST_DATA_BIT;
               dclk_en_i=1'b1;
               load_count_i=1'b1;
               decr_bigcount_i=1'b1;
               read_on_posedge_i=1'b1;
           end */
           
           DONE_STATE:
           begin
               if(READ_ONE_DATA_SET_FROM_DDC==1'b1)
               begin
                   FSMn=DONE_STATE;
                   done_reading_data_set_from_ddc_i=1'b1;
               end
               else
               begin
                   FSMn=IDLE;
               end
           end
           
       endcase        
    end


		 

endmodule
