`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    16:55:09 01/06/06
// Design Name:    
// Module Name:    OPCODE_PROC
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module OPCODE_PROC(	FPGA_CLK,
							FPGA_RESET,

							USB_READ_DATA_AVAILABLE,
							READ_DATA_PROCESSED,
							DATA_FROM_USB,

							CONV_LOW_REG,
							CONV_HIGH_REG,
							CONV_SEL,
							DIVXCLK_LOW_REG,
							DIVXCLK_HIGH_REG,
							DDC_CLK_SEL,

							BITS_TO_READ,
							FORMAT,

							DIVXCLK_DATA_LOW_REG,
							DIVXCLK_DATA_HIGH_REG,

							DVALIDS_TO_IGNORE,	  //Ignore	0
							DVALIDS_TO_CAPTURE,	  //Readings 1
							START_CONVERSIONS,	  //start_conversions 1 and 0
							DONE_WITH_CONVERSIONS,
							HARDWARE_TRIGGER_EN,

							DCLK_WAIT_COUNT,
							DDC_RESETN_OUT,
							
							OPCODE_DATA_OUTPUT,						//opcode_data_output_w[15:0]
							OPCODE_DATA_AVAILABLE_FOR_WRITE,		//opcode_data_available_for_write_w
							USB_WRITE_DATA_REQUESTED,			   //usb_write_data_requested_w
							OPCODE_DATA_LOADED,				      //opcode_data_loaded_w
							USB_WRITE_DATA_PROCESSED,		      //usb_write_data_processed_w

							DDC_TESTMODE,
							DDC_RANGE,
							DDC_FORMAT,
							DDC_SPEED,

							FIRMWARE_VERSION
							);

input	FPGA_CLK;
input FPGA_RESET;

input [15:0] FIRMWARE_VERSION;

input USB_READ_DATA_AVAILABLE;

output READ_DATA_PROCESSED;
reg READ_DATA_PROCESSED;

input [15:0] DATA_FROM_USB;

output [17:0] CONV_LOW_REG, CONV_HIGH_REG;
reg [17:0] CONV_LOW_REG, CONV_HIGH_REG;

output [1:0] CONV_SEL;
reg [1:0] CONV_SEL;

output [3:0] DIVXCLK_LOW_REG, DIVXCLK_HIGH_REG;
reg [3:0] DIVXCLK_LOW_REG, DIVXCLK_HIGH_REG;

output [2:0] DDC_CLK_SEL;
reg [2:0] DDC_CLK_SEL;

output [14:0] BITS_TO_READ;
reg [14:0] BITS_TO_READ;

output FORMAT;
reg FORMAT;

output [3:0] DIVXCLK_DATA_LOW_REG, DIVXCLK_DATA_HIGH_REG;
reg [3:0] DIVXCLK_DATA_LOW_REG, DIVXCLK_DATA_HIGH_REG;


output [7:0] DVALIDS_TO_IGNORE;
reg [7:0] DVALIDS_TO_IGNORE;
output [23:0] DVALIDS_TO_CAPTURE;
reg [23:0] DVALIDS_TO_CAPTURE;
output START_CONVERSIONS;
reg START_CONVERSIONS;
input DONE_WITH_CONVERSIONS;
output HARDWARE_TRIGGER_EN;
reg HARDWARE_TRIGGER_EN;

output [15:0] DCLK_WAIT_COUNT;
reg [15:0] DCLK_WAIT_COUNT;

output DDC_RESETN_OUT;
reg DDC_RESETN_OUT;

output [15:0] OPCODE_DATA_OUTPUT;
reg [15:0] OPCODE_DATA_OUTPUT;

output OPCODE_DATA_AVAILABLE_FOR_WRITE;
reg OPCODE_DATA_AVAILABLE_FOR_WRITE;
input USB_WRITE_DATA_REQUESTED;
output OPCODE_DATA_LOADED;
reg OPCODE_DATA_LOADED;
input USB_WRITE_DATA_PROCESSED;

output DDC_TESTMODE;
output [2:0] DDC_RANGE;
output DDC_FORMAT;
output DDC_SPEED;

reg DDC_TESTMODE;
reg [2:0] DDC_RANGE;
reg DDC_FORMAT;
reg DDC_SPEED;

reg READ_DATA_PROCESSED_i;
reg usb_read_data_available_gated;
reg FSM, FSMn;

reg 	[3:0]	oFSM, oFSMn;
reg	[7:0] reg_address;
reg 	data_available_for_write_i;
reg	reset_reg_address_i;
reg	data_loaded_for_usb_i;
reg	incr_reg_address_i;
reg	usb_write_data_requested_gated;
reg	usb_write_data_processed_gated;
reg   read_out_trigger;

parameter	oIDLE=4'h0,
				oDATA_AVAILABLE_NOW_WAIT=4'h1,
				oDATA_LOADED_FOR_USB=4'h2,
				oEVALUATE_NEXT_REGISTER=4'h3,
				oDONE=4'hF;



parameter IDLE=1'b0;
parameter DO_OP=1'b1;

parameter RESET_ALL = 8'hFF;



//reg NO_OP_i,
reg LOAD_CONV_LOW_REG_MSB_i,
  	 LOAD_CONV_LOW_REG_MIDB_i,
  	 LOAD_CONV_LOW_REG_LSB_i,
  	 LOAD_CONV_HIGH_REG_MSB_i,
  	 LOAD_CONV_HIGH_REG_MIDB_i,
  	 LOAD_CONV_HIGH_REG_LSB_i,
  	 LOAD_DIVXCLK_REGS_i,
  	 LOAD_DDC_CLK_SEL_i,
  	 LOAD_CHANNELS_AND_FORMAT_i,
  	 LOAD_DIVXCLK_DATA_REGS_i,
  	 LOAD_DVALIDS_TO_IGNORE_i,
  	 LOAD_DVALIDS_TO_CAPTURE_LSB_i,
  	 LOAD_DVALIDS_TO_CAPTURE_MIDB_i,
  	 LOAD_DVALIDS_TO_CAPTURE_MSB_i,
  	 LOAD_START_CONVERSIONS_i,
	 LOAD_DCLK_WAIT_COUNT_MSB_i,
	 LOAD_DCLK_WAIT_COUNT_LSB_i,
	 LOAD_DDC_RESETN_OUT_i,	  
	 LOAD_HARDWARE_TRIGGER_EN_i,
	 LOAD_read_out_trigger_i,


   	 LOAD_testmode_i,
	 LOAD_range2_i,
	 LOAD_range1_i,
	 LOAD_range0_i,
	 LOAD_format_i,
	 LOAD_speed_i,

  	 RESET_ALL_i;

//synthesis attribute clock_signal READ_DATA_PROCESSED yes;

always @(posedge FPGA_CLK or negedge FPGA_RESET)
  begin
  if(FPGA_RESET==1'b0)
    begin
	 CONV_LOW_REG[17:0] = 18'b00__0000_0110__0100_0000;
	 CONV_HIGH_REG[17:0] = 18'b00__0000_0110__0100_0000;
	 CONV_SEL[1:0] = 2'b00;
	 DIVXCLK_LOW_REG[3:0] = 4'h4;
	 DIVXCLK_HIGH_REG[3:0] = 4'h4;
	 DDC_CLK_SEL[2:0] = 3'b001;
	 BITS_TO_READ[14:0] = 15'h0280;    //32 channels of 20 bits
	 FORMAT = 1'b1;
	 DIVXCLK_DATA_LOW_REG[3:0] = 4'h1;
	 DIVXCLK_DATA_HIGH_REG[3:0] = 4'h1;
	 DVALIDS_TO_IGNORE[7:0]=8'h02;
	 DVALIDS_TO_CAPTURE[23:0]=24'h000002;
	 START_CONVERSIONS=1'b0;
	 DCLK_WAIT_COUNT[15:0]=16'h0000;
	 DDC_RESETN_OUT=1'b1;	
	 HARDWARE_TRIGGER_EN=1'b0;
	 read_out_trigger=1'b0;
	 DDC_TESTMODE=1'b0;
	 DDC_RANGE[2:0]=3'b101;
	 DDC_FORMAT=1'b1;
	 DDC_SPEED=1'b0;
	 end
  else
  	 begin

	     if(RESET_ALL_i==1'b1)					 //FF
		    begin
			 CONV_LOW_REG[17:0] = 18'b00__0000_0110__0100_0000;
	 		 CONV_HIGH_REG[17:0] = 18'b00__0000_0110__0100_0000;
			 CONV_SEL[1:0]=2'b00;
	 		 DIVXCLK_LOW_REG[3:0] = 4'b0100;	//4+1 = 5; 5+5 is 80MHz div 10, so 8MHz = DDC CLK.
	 		 DIVXCLK_HIGH_REG[3:0] = 4'b0100;
	       DDC_CLK_SEL[2:0] = 3'b001;
			 BITS_TO_READ[14:0] = 15'h0280;    //32 channels of 20 bits
	 	    FORMAT = 1'b1;
			 DIVXCLK_DATA_LOW_REG[3:0] = 4'h1;
	 		 DIVXCLK_DATA_HIGH_REG[3:0] = 4'h1;
			 DVALIDS_TO_IGNORE[7:0]=8'h02;
			 DVALIDS_TO_CAPTURE[23:0]=24'h000002;
			 START_CONVERSIONS=1'b0; 
			 DCLK_WAIT_COUNT[15:0]=16'h0000;
			 DDC_RESETN_OUT=1'b1;
			 HARDWARE_TRIGGER_EN=1'b0;
			 read_out_trigger=1'b0;
			 DDC_TESTMODE=1'b0;
			 DDC_RANGE[2:0]=3'b101;
			 DDC_FORMAT=1'b1;
			 DDC_SPEED=1'b0;
	       end

	     if(LOAD_CONV_LOW_REG_MSB_i==1'b1)	 //01
		    begin							
			 CONV_LOW_REG[17:16] = DATA_FROM_USB[1:0];
		    end  
	     if(LOAD_CONV_LOW_REG_MIDB_i==1'b1)	 //02
		    begin
			 CONV_LOW_REG[15:8] = DATA_FROM_USB[7:0];
		    end  
	     if(LOAD_CONV_LOW_REG_LSB_i==1'b1)	 //03
		    begin
			 CONV_LOW_REG[7:0] = DATA_FROM_USB[7:0];
		    end

		    
	     if(LOAD_CONV_HIGH_REG_MSB_i==1'b1)	 //04
		    begin
			 CONV_HIGH_REG[17:16] = DATA_FROM_USB[1:0];
			 CONV_SEL[1:0] = DATA_FROM_USB[3:2];
		    end  
	     if(LOAD_CONV_HIGH_REG_MIDB_i==1'b1)	 //05
		    begin
			 CONV_HIGH_REG[15:8] = DATA_FROM_USB[7:0];
		    end  
	     if(LOAD_CONV_HIGH_REG_LSB_i==1'b1)	 //06
		    begin
			 CONV_HIGH_REG[7:0] = DATA_FROM_USB[7:0];
		    end

		  if(LOAD_DIVXCLK_REGS_i==1'b1)			 //07
		    begin
			 DIVXCLK_LOW_REG[3:0] = DATA_FROM_USB[3:0];
	 		 DIVXCLK_HIGH_REG[3:0] = DATA_FROM_USB[7:4];
		    end
		  if(LOAD_DDC_CLK_SEL_i==1'b1)			 //08
		    begin
			 DDC_CLK_SEL[2:0] = DATA_FROM_USB[2:0];
			 end

		  if(LOAD_CHANNELS_AND_FORMAT_i==1'b1) //09
		    begin
			   FORMAT=DATA_FROM_USB[4];
			   if(DATA_FROM_USB[4]==1'b0) // 0 = 16 bit
				  begin
			     case(DATA_FROM_USB[3:0])
				  		default:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0000_1111;  //1   
								BITS_TO_READ[14:0] = 15'h0010;  //1   
							end
				  		4'b0000:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0000_1111;  //1   
								BITS_TO_READ[14:0] = 15'h0010;  //1
							end
				  		4'b0001:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0001_1111;	//2 		
								BITS_TO_READ[14:0] = 15'h0020;  //2
							end
						4'b0010:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0011_1111;	//4 
								BITS_TO_READ[14:0] = 15'h0040;  //4
							end
				  		4'b0011:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0111_1111;	//8 
								BITS_TO_READ[14:0] = 15'h0080;  //8  
							end
				  		4'b0100:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__1111_1111;	//16 
								BITS_TO_READ[14:0] = 15'h0100;  //16 
							end
				  		4'b0101:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0001__1111_1111;	//32 
								BITS_TO_READ[14:0] = 15'h0200;  //32 
							end
				  		4'b0110:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0011__1111_1111;	//64 
								BITS_TO_READ[14:0] = 15'h0400;  //64 
							end
				  		4'b0111:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0111__1111_1111;	//128 
								BITS_TO_READ[14:0] = 15'h0800;  //128
							end
				  		4'b1000:
							begin
								//BITS_TO_READ[14:0] = 15'b000_1111__1111_1111;	//256 
								BITS_TO_READ[14:0] = 15'h1000;  //256
							end
				  		4'b1001:
							begin
								//BITS_TO_READ[14:0] = 15'b001_1111__1111_1111;	//512 
								BITS_TO_READ[14:0] = 15'h2000;  //512
							end
				  		4'b1010:
							begin
								//BITS_TO_READ[14:0] = 15'b011_1111__1111_1111;	//1024 
								BITS_TO_READ[14:0] = 15'h4000;  //1024
							end
						4'b1011:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0000_0000;	//0 
								BITS_TO_READ[14:0] = 15'h0000;  //0
							end
						   
						4'b1111:  //this is a case never to be used!
							begin
							   BITS_TO_READ[14:0] = 15'h7FFF;  
							end
						endcase
				  end
				else //(DATA_FROM_USB[4]==1'b1)  // 1 = 20 bit
				  begin
			     		case(DATA_FROM_USB[3:0])
							default:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__0001_0011;  //1
								   BITS_TO_READ[14:0] = 15'h0014;  //1   5'b10100=5'h0014
								end
							4'b0000:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__0001_0011;  //1
								   BITS_TO_READ[14:0] = 15'h0014;  //1   5'b10100=5'h0014
								end
							4'b0001:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__0010_0111;	//2 
								   BITS_TO_READ[14:0] = 15'h0028;  //1   5'b10100=5'h0014
								end
							4'b0010:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__0100_1111;	//4
								   BITS_TO_READ[14:0] = 15'h0050;  //1   5'b10100=5'h0014
								end
							4'b0011:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__1001_1111;	//8 
								   BITS_TO_READ[14:0] = 15'h00A0;  //1   5'b10100=5'h0014
								end
							4'b0100:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0001__0011_1111;	//16 
								   BITS_TO_READ[14:0] = 15'h0140;  //1   5'b10100=5'h0014
								end
							4'b0101:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0010__0111_1111;	//32	
								   BITS_TO_READ[14:0] = 15'h0280;  //1   5'b10100=5'h0014
								end
							4'b0110:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0100__1111_1111;	//64	
								   BITS_TO_READ[14:0] = 15'h0500;  //1   5'b10100=5'h0014
								end
							4'b0111:
								begin
									//BITS_TO_READ[14:0] = 15'b000_1001__1111_1111;	//128	
								   BITS_TO_READ[14:0] = 15'h0A00;  //1   5'b10100=5'h0014 
								end
							4'b1000:
								begin
									//BITS_TO_READ[14:0] = 15'b001_0011__1111_1111;	//256	
								   BITS_TO_READ[14:0] = 15'h1400;  //1   5'b10100=5'h0014 
								end
							4'b1001:
								begin
									//BITS_TO_READ[14:0] = 15'b010_0111__1111_1111;	//512	
								   BITS_TO_READ[14:0] = 15'h2800;  //1   5'b10100=5'h0014
								end
							4'b1010:
								begin
									//BITS_TO_READ[14:0] = 15'b100_1111__1111_1111;	//1024  
								   BITS_TO_READ[14:0] = 15'h5000;  //1   5'b10100=5'h0014
								end
							4'b1011:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__0000_0000;	//0
								   BITS_TO_READ[14:0] = 15'h0000;  //1   5'b10100=5'h0014
								end
						   
							4'b1111:  //this is a case never to be used!
								begin
								   BITS_TO_READ[14:0] = 15'h7FFF;  
								end
						endcase
				  end
			 end


		  if(LOAD_DIVXCLK_DATA_REGS_i==1'b1)			 //0A
		    begin
			 DIVXCLK_DATA_LOW_REG[3:0] = DATA_FROM_USB[3:0]; //4'b1110;
	 		 DIVXCLK_DATA_HIGH_REG[3:0] = DATA_FROM_USB[7:4]; //4'b1110;
		    end

		  if(LOAD_DVALIDS_TO_IGNORE_i==1'b1)
		    begin
			 DVALIDS_TO_IGNORE[7:0] = DATA_FROM_USB[7:0];
			 end

		  if(LOAD_DVALIDS_TO_CAPTURE_LSB_i==1'b1)
		    begin
			 DVALIDS_TO_CAPTURE[7:0] = DATA_FROM_USB[7:0];
			 end

		  if(LOAD_DVALIDS_TO_CAPTURE_MIDB_i==1'b1)
		    begin
			 DVALIDS_TO_CAPTURE[15:8] = DATA_FROM_USB[7:0];
			 end

		  if(LOAD_DVALIDS_TO_CAPTURE_MSB_i==1'b1)
		    begin
			 DVALIDS_TO_CAPTURE[23:16] = DATA_FROM_USB[7:0];
			 end

		  if(LOAD_START_CONVERSIONS_i==1'b1)
		    begin
			 START_CONVERSIONS = DATA_FROM_USB[0];
			 end


		 if(LOAD_DCLK_WAIT_COUNT_MSB_i==1'b1)
			 begin
			 DCLK_WAIT_COUNT[15:8]=DATA_FROM_USB[7:0];
			 end

		 if(LOAD_DCLK_WAIT_COUNT_LSB_i==1'b1)
			 begin
			 DCLK_WAIT_COUNT[7:0]=DATA_FROM_USB[7:0];
			 end

		 if(LOAD_DDC_RESETN_OUT_i==1'b1)
			 begin
			 DDC_RESETN_OUT=DATA_FROM_USB[0];	
			 end

		 if(LOAD_HARDWARE_TRIGGER_EN_i==1'b1)
		 	 begin
			 HARDWARE_TRIGGER_EN=DATA_FROM_USB[0];
			 end









		 if(LOAD_testmode_i==1'b1)
		 	 begin
			 	DDC_TESTMODE=DATA_FROM_USB[5];
			 end
		 if(LOAD_range2_i==1'b1)
		 	 begin
			 	DDC_RANGE[2]=DATA_FROM_USB[4];
			 end
		 if(LOAD_range1_i==1'b1)
		 	 begin
			 	DDC_RANGE[1]=DATA_FROM_USB[3];
			 end	
		 if(LOAD_range0_i==1'b1)
		 	 begin
			 	DDC_RANGE[0]=DATA_FROM_USB[2];
			 end	  
		 if(LOAD_format_i==1'b1)
		 	 begin
			 	DDC_FORMAT=DATA_FROM_USB[1];
			 end
		 if(LOAD_speed_i==1'b1)
		 	 begin
			 	DDC_SPEED=DATA_FROM_USB[1];
			 end


		 if(LOAD_read_out_trigger_i==1'b1)
 		 	 begin
			 read_out_trigger=DATA_FROM_USB[0];
			 end
	 
	 end
  end

always @( posedge FPGA_CLK or negedge FPGA_RESET )
  begin
    if(FPGA_RESET==1'b0)
	   begin
		FSM=IDLE;
		READ_DATA_PROCESSED=1'b1;
		usb_read_data_available_gated=1'b0;
		end
	 else
	   begin
		FSM=FSMn;
		READ_DATA_PROCESSED=READ_DATA_PROCESSED_i;
		usb_read_data_available_gated=USB_READ_DATA_AVAILABLE;
		end
  end

always @(	FSM or
				usb_read_data_available_gated or
				DATA_FROM_USB[15] or
				DATA_FROM_USB[14] or
				DATA_FROM_USB[13] or
				DATA_FROM_USB[12] or
				DATA_FROM_USB[11] or
				DATA_FROM_USB[10] or
				DATA_FROM_USB[9] or
				DATA_FROM_USB[8]
				)
  begin
  	 FSMn=FSM;
  	 READ_DATA_PROCESSED_i=1'b0;
  	 
  	 //NO_OP_i=1'b0;
  	 LOAD_CONV_LOW_REG_MSB_i=1'b0;
  	 LOAD_CONV_LOW_REG_MIDB_i=1'b0;
  	 LOAD_CONV_LOW_REG_LSB_i=1'b0;
  	 LOAD_CONV_HIGH_REG_MSB_i=1'b0;
  	 LOAD_CONV_HIGH_REG_MIDB_i=1'b0;
  	 LOAD_CONV_HIGH_REG_LSB_i=1'b0;
  	 LOAD_DIVXCLK_REGS_i=1'b0;
  	 LOAD_DDC_CLK_SEL_i=1'b0;
  	 LOAD_CHANNELS_AND_FORMAT_i=1'b0;
  	 LOAD_DIVXCLK_DATA_REGS_i=1'b0;
  	 LOAD_DVALIDS_TO_IGNORE_i=1'b0;
  	 LOAD_DVALIDS_TO_CAPTURE_LSB_i=1'b0;
  	 LOAD_DVALIDS_TO_CAPTURE_MIDB_i=1'b0;
  	 LOAD_DVALIDS_TO_CAPTURE_MSB_i=1'b0;
  	 LOAD_START_CONVERSIONS_i=1'b0;  
	 LOAD_DCLK_WAIT_COUNT_MSB_i=1'b0;
	 LOAD_DCLK_WAIT_COUNT_LSB_i=1'b0;
	 LOAD_DDC_RESETN_OUT_i=1'b0;
	 LOAD_HARDWARE_TRIGGER_EN_i=1'b0;
  	 RESET_ALL_i=1'b0;
	 LOAD_read_out_trigger_i=1'b0;
	 LOAD_testmode_i=1'b0;
	 LOAD_range2_i=1'b0;
	 LOAD_range1_i=1'b0;
	 LOAD_range0_i=1'b0;
	 LOAD_format_i=1'b0;
	 LOAD_speed_i=1'b0;

  	 case(FSM)
      IDLE:
		  begin
			if(usb_read_data_available_gated==1'b1)
			   begin
					FSMn=DO_OP;
					//if(DATA_FROM_USB[15:8]==8'h00) NO_OP_i=1'b1; 
					if(DATA_FROM_USB[15:8]==8'h01) LOAD_CONV_LOW_REG_MSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h02) LOAD_CONV_LOW_REG_MIDB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h03) LOAD_CONV_LOW_REG_LSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h04) LOAD_CONV_HIGH_REG_MSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h05) LOAD_CONV_HIGH_REG_MIDB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h06) LOAD_CONV_HIGH_REG_LSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h07) LOAD_DIVXCLK_REGS_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h08) LOAD_DDC_CLK_SEL_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h09) LOAD_CHANNELS_AND_FORMAT_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h0A) LOAD_DIVXCLK_DATA_REGS_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h0C) LOAD_DVALIDS_TO_IGNORE_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h0D) LOAD_DVALIDS_TO_CAPTURE_LSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h0E) LOAD_DVALIDS_TO_CAPTURE_MIDB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h0F) LOAD_DVALIDS_TO_CAPTURE_MSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h10) LOAD_START_CONVERSIONS_i=1'b1;		
					if(DATA_FROM_USB[15:8]==8'h13) LOAD_DCLK_WAIT_COUNT_MSB_i=1'b1;
	 				if(DATA_FROM_USB[15:8]==8'h14) LOAD_DCLK_WAIT_COUNT_LSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h15) LOAD_DDC_RESETN_OUT_i=1'b1;	
					if(DATA_FROM_USB[15:8]==8'h16) LOAD_HARDWARE_TRIGGER_EN_i=1'b1;

				   if(DATA_FROM_USB[15:8]==8'h22) LOAD_testmode_i=1'b1;
				   if(DATA_FROM_USB[15:8]==8'h23) LOAD_range2_i=1'b1;
				   if(DATA_FROM_USB[15:8]==8'h24) LOAD_range1_i=1'b1;
				   if(DATA_FROM_USB[15:8]==8'h25) LOAD_range0_i=1'b1;
				   if(DATA_FROM_USB[15:8]==8'h26) LOAD_format_i=1'b1;
				   if(DATA_FROM_USB[15:8]==8'h27) LOAD_speed_i=1'b1;

					if(DATA_FROM_USB[15:8]==8'hD0) LOAD_read_out_trigger_i=1'b1;

					if(DATA_FROM_USB[15:8]==8'hFF) RESET_ALL_i=1'b1;
					READ_DATA_PROCESSED_i=1'b1;
				end
			 else
			 	begin
					FSMn=IDLE;
				end
		  end
		DO_OP:
		  begin

		    if(usb_read_data_available_gated==1'b1) //if it is still 1, then just sit here doing nothing
		      begin
				  READ_DATA_PROCESSED_i=1'b1;
		  	     FSMn=DO_OP;
				end
			 else  //when it goes back to 0, then go back to waiting for the next one.
				begin
				  READ_DATA_PROCESSED_i=1'b0;
		  	     FSMn=IDLE;
				end
		  end
	 endcase
  end //end FSM block




always @(posedge FPGA_CLK or negedge FPGA_RESET)
	begin
		if(FPGA_RESET==1'b0)
			begin
				OPCODE_DATA_OUTPUT[15:0]=16'h0000;
		//		decSREG_C = 1'b0;
			end
		else
			begin
				OPCODE_DATA_OUTPUT[15:8]=reg_address[7:0];
			
				case(reg_address[7:0])
					8'h01: OPCODE_DATA_OUTPUT[7:0]={6'h00,CONV_LOW_REG[17:16]};
					8'h02: OPCODE_DATA_OUTPUT[7:0]=CONV_LOW_REG[15:8];
					8'h03: OPCODE_DATA_OUTPUT[7:0]=CONV_LOW_REG[7:0];
					8'h04: OPCODE_DATA_OUTPUT[7:0]={4'h0,{CONV_SEL[1:0],CONV_HIGH_REG[17:16]}};
					8'h05: OPCODE_DATA_OUTPUT[7:0]=CONV_HIGH_REG[15:8];
					8'h06: OPCODE_DATA_OUTPUT[7:0]=CONV_HIGH_REG[7:0];
					8'h07: OPCODE_DATA_OUTPUT[7:0]={DIVXCLK_HIGH_REG[3:0],DIVXCLK_LOW_REG[3:0]};
					8'h08: OPCODE_DATA_OUTPUT[7:0]={5'h00,DDC_CLK_SEL[2:0]};
					8'h09: OPCODE_DATA_OUTPUT[7:0]={3'h0,{FORMAT,4'h0}}; //this one does not trasfer ideally, so 4'h0;
					8'h0A: OPCODE_DATA_OUTPUT[7:0]={DIVXCLK_DATA_HIGH_REG[3:0],DIVXCLK_DATA_LOW_REG[3:0]};
					8'h0C: OPCODE_DATA_OUTPUT[7:0]=DVALIDS_TO_IGNORE[7:0];
					8'h0D: OPCODE_DATA_OUTPUT[7:0]=DVALIDS_TO_CAPTURE[7:0];
					8'h0E: OPCODE_DATA_OUTPUT[7:0]=DVALIDS_TO_CAPTURE[15:8];
					8'h0F: OPCODE_DATA_OUTPUT[7:0]=DVALIDS_TO_CAPTURE[23:16];
					8'h10: OPCODE_DATA_OUTPUT[7:0]={6'h00,{DONE_WITH_CONVERSIONS,START_CONVERSIONS}};
					8'h13: OPCODE_DATA_OUTPUT[7:0]=DCLK_WAIT_COUNT[15:8];
					8'h14: OPCODE_DATA_OUTPUT[7:0]=DCLK_WAIT_COUNT[7:0];
					8'h15: OPCODE_DATA_OUTPUT[7:0]={7'h00,DDC_RESETN_OUT};
					8'h16: OPCODE_DATA_OUTPUT[7:0]={7'h00,HARDWARE_TRIGGER_EN};
				   8'h22: OPCODE_DATA_OUTPUT[7:0]={7'h00,DDC_TESTMODE};
				   8'h23: OPCODE_DATA_OUTPUT[7:0]={7'h00,DDC_RANGE[2]};
				   8'h24: OPCODE_DATA_OUTPUT[7:0]={7'h00,DDC_RANGE[1]};
				   8'h25: OPCODE_DATA_OUTPUT[7:0]={7'h00,DDC_RANGE[0]};
				   8'h26: OPCODE_DATA_OUTPUT[7:0]={7'h00,DDC_FORMAT};
				   8'h27: OPCODE_DATA_OUTPUT[7:0]={7'h00,DDC_SPEED};
					8'h5E: OPCODE_DATA_OUTPUT[7:0]=FIRMWARE_VERSION[15:8];
					8'h5F: OPCODE_DATA_OUTPUT[7:0]=FIRMWARE_VERSION[7:0];
					default: OPCODE_DATA_OUTPUT[7:0]=8'h00;
				endcase
			end
	end


always @(posedge FPGA_CLK or negedge FPGA_RESET)
	begin
		if(FPGA_RESET==1'b0)
			begin
				oFSM=oIDLE;
				OPCODE_DATA_AVAILABLE_FOR_WRITE=1'b0;
				OPCODE_DATA_LOADED=1'b0;
				usb_write_data_requested_gated=1'b0;
				usb_write_data_processed_gated=1'b0;
				reg_address[7:0]=8'h00;
			end
		else
			begin
				oFSM=oFSMn;
				OPCODE_DATA_AVAILABLE_FOR_WRITE=data_available_for_write_i;
				OPCODE_DATA_LOADED=data_loaded_for_usb_i;
				usb_write_data_requested_gated=USB_WRITE_DATA_REQUESTED;
				usb_write_data_processed_gated=USB_WRITE_DATA_PROCESSED;
				if(reset_reg_address_i==1'b1) reg_address[7:0]=8'h00;
				if(incr_reg_address_i==1'b1) reg_address[7:0]=reg_address[7:0]+8'h01;
			end

	end

always @(	oFSM or
				read_out_trigger or
				usb_write_data_requested_gated or
				usb_write_data_processed_gated or
				reg_address
				)
	begin
		data_available_for_write_i=1'b1;
		reset_reg_address_i=1'b0;
		data_loaded_for_usb_i=1'b0;
		incr_reg_address_i=1'b0;
		
		case(oFSM)
			oIDLE:
				begin
					if(read_out_trigger==1'b1)
						begin
							oFSMn=oDATA_AVAILABLE_NOW_WAIT;
							reset_reg_address_i=1'b1;
						end
					else
						begin
							oFSMn=oIDLE;
							data_available_for_write_i=1'b0;
						end
				end
		
			oDATA_AVAILABLE_NOW_WAIT:
				begin
					if(usb_write_data_requested_gated==1'b1)
						begin
							oFSMn=oDATA_LOADED_FOR_USB;
						end
					else
						begin
							oFSMn=oDATA_AVAILABLE_NOW_WAIT;
						end
				end

			oDATA_LOADED_FOR_USB:
				begin
					data_loaded_for_usb_i=1'b1;
					if(usb_write_data_processed_gated==1'b1)
						begin
							oFSMn=oEVALUATE_NEXT_REGISTER;
						end
					else
						begin
							oFSMn=oDATA_LOADED_FOR_USB;
						end
				end

			oEVALUATE_NEXT_REGISTER:
				begin
					if(reg_address[7:0]==8'hFE)
						begin
							oFSMn=oDONE;
							data_available_for_write_i=1'b0;
						end
					else
						begin
							oFSMn=oDATA_AVAILABLE_NOW_WAIT;
							incr_reg_address_i=1'b1;
							
						end
				end
			
			oDONE:
				begin
					if(read_out_trigger==1'b0)
						begin
							oFSMn=oIDLE;
							data_available_for_write_i=1'b0;
							reset_reg_address_i=1'b1;
						end
					else
						begin
							oFSMn=oDONE;
							data_available_for_write_i=1'b0;
						end
				end

			default:
				begin
					oFSMn=oIDLE;
					data_available_for_write_i=1'b0;
				end

		endcase

	end


endmodule
