`timescale 1ns / 100ps

module top(	FPGA_CLK,
				FPGA_RESET,
				//GCLK8,
				//P175,
				//P174,
				//P169,
				//P159, 
				IFCLK_I,
				INT0,
				INT1, 
				SLOE_O,
				WU2, 
				FIFOADR_O, 
				PKTEND_O,
				FLAGD_I_SLCS,
				PB,
				PC,
				PD,
				PE,
				FLAGA_I,
				FLAGB_I, 
				FLAGC_I, 
				CTL, 
				SLRD_O, 
				SLWR_O,
				RDY,
				T,
				INT4,
				INT5,
				RAM_ADDRESS,
				RAM_DATA,
				CSn1,
				CSn2,
				OEn,
				WEn,
				DCIO3,  // 114-gnd
				DCIO4,  // 114-gnd
				DCIO5,  // 114-TEST
				DCIO7,  // 114-RESETn
				DCIO10, // 114-gnd
				DCIO11, // 114-gnd
				DCIO13, // 114-DINn
				DCIO14, // 114-DIN
				DCIO17, // 114-DCLKn
				DCIO18, // 114-DCLK
				DCIO20, // EXTRA1
				DCIO21, // 114-gnd
				DCIO22, // 
				DCIO23, // 114-gnd
				DCIO25, // 114-DVALIDn
				DCIO27, // 114-gnd
				DCIO29, // 114-CONV
				DCIO30, // CONVn   
				DCIO32, // 114-gnd 112-DXMIT
				DCIO33, // 114-gnd
				DCIO35, // 114-DOUT
				DCIO36, // DOUTn   
				DCIO38, // EXTRA2
				DCIO39, // 114-gnd
				DCIO41, // 114-FORMAT  
				DCIO43, // 114-SPEED   			 
				DCIO45, // 114-RANGE0  
				DCIO46, // 114-RANGE1  
				DCIO47, // 114-RANGE2  
				DCIO49, // 114-CLK
				EXTRA_IP,
				EXTRA_IO_SMA
				);


/////////////////////////////////////////////////////////////////////////////////////
// IO LINES
/////////////////////////////////////////////////////////////////////////////////////

//### Exclusively FPGA ###############################################
input FPGA_CLK; // P177 (GCLK 4 Line)
input FPGA_RESET; // P194
//input GCLK8; //P183

//### CYPRESS-to-FPGA ###############################################
input IFCLK_I; // P186 (GCLK 11 Line)

/*** Port A ***/
output INT0; // P12 
output INT1; // P11 

output SLOE_O;	// P9
wire   SLOE_O;

output WU2; //P8

output [1:0] FIFOADR_O; // [1:0] = [ P4:P5 ]
wire   [1:0] FIFOADR_O;   

output PKTEND_O; // P3
wire   PKTEND_O;

output FLAGD_I_SLCS; //P2

/*** Port B ***/
inout [7:0] PB; // [7:0] = [ P40:P41:P42:P45:P47:P48:P49:P50 ]
tri   [7:0] PB;

/*** Port C ***/
output [7:0] PC; // [7:0] = [ P29:P30:P31:P33:P34:P35:P36:P39 ]

/*** Port D ***/
inout [7:0] PD; // [7:0] = [ P15:P16:P18:P19:P22:P23:P24:P25 ]
tri   [7:0] PD;

/*** Port E ***/
output [7:0] PE; // [7:0] = [ P28:P197:P199:P200:P202:P203:P205:P206 ]

/*** CTL Port (always input) ***/
input FLAGA_I; // P6
input FLAGB_I; // P14
input FLAGC_I;	// P26
input [5:3] CTL; // [5:3] [ P32:P43:P51 ]

/*** RDY Port ***/
output SLRD_O; 
wire   SLRD_O;

output SLWR_O;
wire   SLWR_O;

output [5:2] RDY; // (RDY4 = GCLK 10, RDY5 = GCLK 6
wire [5:2] RDY;

/*** T Port ***/
output [2:0] T; //
wire [2:0] T;

/*** INTerrupts ***/
output INT4;
output INT5;

//### FPGA-to-MEMORY ###############################################
output [18:0] RAM_ADDRESS;
wire [18:0] RAM_ADDRESS;

inout [15:0] RAM_DATA;
tri [15:0] RAM_DATA;

output CSn1, CSn2, OEn, WEn;
wire CSn1, CSn2, OEn, WEn;

		
//### FPGA-to-DDC/DAUGHTER-CARD-HEADER #############################


output 		DCIO3;
output		DCIO4;
output		DCIO5;
output		DCIO7;  //
output		DCIO10;
output		DCIO11;
output		DCIO13; //
output		DCIO14; //
output		DCIO17; //
output		DCIO18; //
output		DCIO20;
output		DCIO21;
output		DCIO22; // 
output		DCIO23;
input			DCIO25; //
output		DCIO27; //
output		DCIO29; //
output		DCIO30; //
output		DCIO32;
output		DCIO33;
input			DCIO35; //
input			DCIO36; //
output		DCIO38;
output		DCIO39;
output		DCIO41; //
output		DCIO43; //
output		DCIO45; //
output		DCIO46; //
output		DCIO47; //
output		DCIO49; //

wire		  		DCIO3;
wire				DCIO4;
wire				DCIO5;
wire				DCIO7;
wire				DCIO10;
wire				DCIO11;
wire				DCIO13;
wire				DCIO14;
wire				DCIO17;
wire				DCIO18;
wire				DCIO20;
wire				DCIO21;
wire				DCIO22;
wire				DCIO23;
//wire				DCIO25;
wire				DCIO27;
wire				DCIO29;
wire				DCIO30;
wire				DCIO32;
wire				DCIO33;
//wire				DCIO35;
//wire				DCIO36;
wire				DCIO38;
wire				DCIO39;
wire				DCIO41;
wire				DCIO43;
wire				DCIO45;
wire				DCIO46;
wire				DCIO47;
wire				DCIO49;

//### FPGA-to-EXTRA-INPUTS ###############################################
input [7:0] EXTRA_IP;

input EXTRA_IO_SMA; //(GCLK 7 Line)
/////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////
// INTERNAL REGISTERS, WIRES, and BUSES
/////////////////////////////////////////////////////////////////////////////////////

//tri [3:0] pb_i;
wire [7:0] pb_i;
wire [7:0] pb_o; 
wire [7:0] pd_i;
wire [7:0] pd_o;

wire usb_io_to_opcode_processor_1_w; //goes to 1 (from USB_IO) when a word is read from the USB and available on the port.
wire opcode_processor_to_usb_io_2_w; //goes to 1	(from FPGA_FIFO) when word on port is processed.

//wire ddc_data_fifo_to_usb_io_1_w; //goes to 1 (from DDC_DATA_FIFO) when a data stream is available.
//wire usb_io_to_ddc_data_fifo_2_w; //goes to 1 (from USB_IO) when the cypress fifo is ready to accept data to write.
//wire ddc_data_fifo_to_usb_io_3_w; //goes to 1 (from DDC_DATA_FIFO) when a word is loaded on the port.
//wire usb_io_to_ddc_data_fifo_4_w; //goes to 1 (from USB_IO) when word is written to Cypress EX-USB chip.

wire [15:0] usb_io_to_opcode_processor_3_busw;
//wire [15:0] ddc_data_fifo_to_usb_io_5_busw;

wire [19:0] data_from_ddc_w;
wire [15:0] data_from_fifo_to_ram_w;
wire [15:0] data_from_fifo_to_usb_w;
wire reserve_ram_for_writing_w;
wire ddc_fifo_write_data_available_w;
wire ram_to_ddc_data_fifo_w;
//wire ddc_fifo_write_data_loaded_w;
wire data_stored_in_ram_w;
wire request_ram_data_w;
wire data_available_from_ram_w;
wire [15:0] data_from_ram_w;
wire ram_fifo_write_data_available_w;
wire usb_write_data_requested_w;
wire ram_fifo_write_data_loaded_w;
wire usb_write_data_processed_w;
wire reset_address_counters_w;

wire [15:0] opcode_data_output_w;
wire opcode_data_available_for_write_w;
wire opcode_data_loaded_w;

wire [15:0] data_for_usbio_write;



wire ddc_reset_o;
wire ddc_din_o;
wire ddc_dclk_o;

wire ddc_dvalid_i;
wire ddc_conv_o;
wire ddc_dout_i;
wire ddc_doutn_i;
wire ddc_clk_o;

wire dxmit_o;

wire ddc_unsynced_dvalidn_i;

wire ddc_testmode_o;
wire [2:0] ddc_range_o;
wire ddc_format_o;
wire ddc_speed_o;

wire [17:0] conv_low_reg_busw;
wire [17:0] conv_high_reg_busw;
wire [3:0] divxclk_low_reg_w;
wire [3:0] divxclk_high_reg_w;
wire [2:0] ddc_clk_sel_w;

wire [3:0] divxclk_data_low_reg_w;
wire [3:0] divxclk_data_high_reg_w;
wire ddc_data_clk_o;
wire ddc_acq_dclk_w;

//wire [31:0] data_for_ram_from_opcode_proc_w;
//wire [18:0] address_for_ram_from_opcode_proc_w;
//wire put_ram_data_on_port_w;
//tri [15:0] ram_data_internal_bus_w;


wire [14:0] bits_to_read_busw;
wire format_setting_from_opcode_w;

//wire [19:0] ddc_data_busw;

wire cap_to_fifo_latch_data_w;
wire fifo_to_cap_data_processed_w;

wire [1:0] conv_sel_busw;

wire trigger_one_reading_w;
wire done_with_one_reading_w;
wire [7:0] dvalids_to_ignore_busw;
wire [23:0] dvalids_to_capture_busw;
wire start_conversions_w;
wire hardware_trigger_en_w;

wire done_with_conversions_w;

wire w_pktend_inhibitor;
wire w_pktend_sent_ack;
wire w_send_pktend;

wire w_ram_data_processed;  
wire w_ready_to_write;

wire w_cont_a0_b1;

wire [15:0] dclk_wait_count_w;
wire sr_empty_gated_w;



wire UnusedPinsOutput_w;





parameter FIRMWARE_VERSION = 16'd996;


/////////////////////////////////////////////////////////////////////////////////////
// ASSIGNMENTS
/////////////////////////////////////////////////////////////////////////////////////

//if output is enabled (sloe=0), then drive PB
//output from cypress disabled
//value of PB when FPGA outputs are enabled.
//PB are the actual xilinx pins to the cypress chip
//pb_i is the internal bus that has the input

assign PB[7:0] = (SLOE_O==1'b1) ? pb_o[7:0] : 8'bzzzzzzzz;
assign PD[7:0] = (SLOE_O==1'b1) ? pd_o[7:0] : 8'bzzzzzzzz;

//output from cypress enabled			
//value of PB when Cypress outputs are enabled.
//pb_o is the internal bus that has the output
assign pb_i[7:0] = PB[7:0];
assign pd_i[7:0] = PD[7:0];
//assign pb_i[3:0] = (SLOE_O==1'b0) ? PB[3:0] : 4'bzzzz;	    


assign WU2=1'b0;
assign INT0=1'b1;
assign INT1=1'b1;
assign FLAGD_I_SLCS=1'b1;
assign PC[7:0]=8'h00;
assign PE[7:0]=8'h00;
assign RDY[5:2]=4'h0;
assign T[2:0]=3'h0;
assign INT4=1'b0;
assign INT5=1'b1;

assign DCIO3=1'b0;
assign DCIO4=1'b0;

assign DCIO5=ddc_testmode_o;

assign DCIO7=ddc_reset_o;

assign DCIO10=1'b0;  
assign DCIO11=1'b0;	

assign DCIO13=~ddc_din_o;
assign DCIO14=ddc_din_o;

assign DCIO17=~ddc_dclk_o;
assign DCIO18=ddc_dclk_o;

assign DCIO20=1'b0; //extra1
assign DCIO21=1'b0; 
assign DCIO22=1'b0;
assign DCIO23=1'b0; 

assign ddc_unsynced_dvalidn_i = DCIO25;

assign DCIO27=1'b0;
assign DCIO29=ddc_conv_o;
assign DCIO30=~ddc_conv_o;

assign DCIO32=dxmit_o;  //DXMIT
assign DCIO33=1'b0;	
assign ddc_dout_i=DCIO35;
assign ddc_doutn_i=DCIO36;
assign DCIO38= ~(ddc_doutn_i || (|CTL[5:3]) || (|EXTRA_IP[7:1]) || EXTRA_IO_SMA || FLAGA_I );	//extra2
assign DCIO39=1'b0;
assign DCIO41=ddc_format_o;
assign DCIO43=ddc_speed_o;
assign DCIO45=ddc_range_o[0];
assign DCIO46=ddc_range_o[1];
assign DCIO47=ddc_range_o[2];
assign DCIO49=ddc_clk_o;

assign ddc_din_o=1'b0;		 //(board_w[1:0] == 2'b01)?1'bz:

assign ddc_dclk_o=ddc_data_clk_o || ddc_acq_dclk_w;




assign data_for_usbio_write[15:0] = (|opcode_data_output_w[15:8]==1'b1) ? opcode_data_output_w[15:0] :	data_from_fifo_to_usb_w[15:0];

/////////////////////////////////////////////////////////////////////////////////////
// MODULE INSTANTIATION
/////////////////////////////////////////////////////////////////////////////////////

INPUT_SYNC dvalid_sync(	.FPGA_CLK(FPGA_CLK),
								.FPGA_RESET(FPGA_RESET),
								.A(ddc_unsynced_dvalidn_i),
								/*.RESET_STATE(1'b0),*/
								.Y(ddc_dvalid_i),
								.CONV(ddc_conv_o),
								.CONT_A0_B1(w_cont_a0_b1)
								);


CLK_GEN ddc_clk_generator(	.FPGA_CLK(FPGA_CLK), 
									.FPGA_RESET(FPGA_RESET), 
									.DDC_CLK_OUT(ddc_clk_o), 
									.DDC_CLK_SEL(ddc_clk_sel_w), 
									.DIVXCLK_LOW_REG(divxclk_low_reg_w), 
									.DIVXCLK_HIGH_REG(divxclk_high_reg_w)
									);

CONV_GEN ddc_conv_generator(	.DDC_CLK(ddc_clk_o), 
										.FPGA_RESET(FPGA_RESET),
										.CONV_LOW_REG(conv_low_reg_busw[17:0]),
										.CONV_HIGH_REG(conv_high_reg_busw[17:0]),
										.CONV_OUT(ddc_conv_o),
										.CONV_SEL(conv_sel_busw)
										);

OPCODE_PROC opcode_processor(	.FPGA_CLK(FPGA_CLK),
										.FPGA_RESET(FPGA_RESET),
										
										.USB_READ_DATA_AVAILABLE(usb_io_to_opcode_processor_1_w),
										.READ_DATA_PROCESSED(opcode_processor_to_usb_io_2_w),
										.DATA_FROM_USB(usb_io_to_opcode_processor_3_busw[15:0]),
										
										
										.CONV_LOW_REG(conv_low_reg_busw[17:0]),
										.CONV_HIGH_REG(conv_high_reg_busw[17:0]),
										.CONV_SEL(conv_sel_busw),
										.DIVXCLK_LOW_REG(divxclk_low_reg_w),
										.DIVXCLK_HIGH_REG(divxclk_high_reg_w),
										.DDC_CLK_SEL(ddc_clk_sel_w),

										.BITS_TO_READ(bits_to_read_busw[14:0]),
										.FORMAT(format_setting_from_opcode_w),
 									
										.DIVXCLK_DATA_LOW_REG(divxclk_data_low_reg_w), 
										.DIVXCLK_DATA_HIGH_REG(divxclk_data_high_reg_w),

										.DVALIDS_TO_IGNORE(dvalids_to_ignore_busw[7:0]),
										.DVALIDS_TO_CAPTURE(dvalids_to_capture_busw[23:0]),
										.START_CONVERSIONS(start_conversions_w),
										.HARDWARE_TRIGGER_EN(hardware_trigger_en_w),

										.DCLK_WAIT_COUNT(dclk_wait_count_w),
										.DDC_RESETN_OUT(ddc_reset_o),

										.OPCODE_DATA_OUTPUT(opcode_data_output_w[15:0]),
										.OPCODE_DATA_AVAILABLE_FOR_WRITE(opcode_data_available_for_write_w),
										.USB_WRITE_DATA_REQUESTED(usb_write_data_requested_w),
										.OPCODE_DATA_LOADED(opcode_data_loaded_w),
										.USB_WRITE_DATA_PROCESSED(usb_write_data_processed_w),

										.DDC_TESTMODE(ddc_testmode_o),
										.DDC_RANGE(ddc_range_o[2:0]),
										.DDC_FORMAT(ddc_format_o),
										.DDC_SPEED(ddc_speed_o),

										.DONE_WITH_CONVERSIONS(done_with_conversions_w),

										.FIRMWARE_VERSION(FIRMWARE_VERSION)
										);

DDC_ACQ_CONTROL ddc_acq_ctrl(	.FPGA_CLK(FPGA_CLK),
										//.DDC_CLK(ddc_clk_o),
										.FPGA_RESET(FPGA_RESET),

										.DVALIDn(ddc_dvalid_i),			  //////////////////////
										.DCLK(ddc_acq_dclk_w),

										.DVALIDS_TO_IGNORE(dvalids_to_ignore_busw[7:0]),	////////////////////////
										.DVALIDS_TO_CAPTURE(dvalids_to_capture_busw[23:0]),/////////////////////////
										.START_CONVERSIONS(start_conversions_w),	/////////////////////////

										.TRIGGER(trigger_one_reading_w),
										.SR_EMPTY_GATED(sr_empty_gated_w),
										.ACK(done_with_one_reading_w),
										.DONE(done_with_conversions_w),

										//.PKTEND_INHIBITOR(w_pktend_inhibitor),

										.RESERVE_RAM_FOR_WRITING(reserve_ram_for_writing_w),
										.RESET_ADDRESS_COUNTERS(reset_address_counters_w),

										.HARDWARE_TRIGGER_EN(hardware_trigger_en_w),
										.HARDWARE_TRIGGER(EXTRA_IP[0])
										);


DDC_DATA_CAP ddc_readback(	.FPGA_CLK(FPGA_CLK),
									.FPGA_RESET(FPGA_RESET),

									.DOUT_IN(ddc_dout_i),

									.CAP_DATA_OUT(data_from_ddc_w[19:0]),

									.BITS_TO_READ(bits_to_read_busw[14:0]),
									.FORMAT(format_setting_from_opcode_w),

									.DATA_READY(cap_to_fifo_latch_data_w),
									.ACK(fifo_to_cap_data_processed_w),
									.READ_ONE_DATA_SET_FROM_DDC(trigger_one_reading_w),
									.DONE_READING_DATA_SET_FROM_DDC(done_with_one_reading_w),

									.DCLK_OUT(ddc_data_clk_o),
									.DIVXCLK_LOW_REG(divxclk_data_low_reg_w),
									.DIVXCLK_HIGH_REG(divxclk_data_high_reg_w),
									.DCLK_WAIT_COUNT(dclk_wait_count_w),

									.DXMIT(dxmit_o)
									);


DDC_DATA_FIFO data_fifo(.FPGA_CLK(FPGA_CLK),
								.FPGA_RESET(FPGA_RESET),

								.DATA_FROM_DDC(data_from_ddc_w[19:0]),
								.A0_OR_B1_DATA(w_cont_a0_b1),

								.DATA_WIDTH(format_setting_from_opcode_w),
								.LATCH_DATA_FROM_DDC(cap_to_fifo_latch_data_w),
								.DATA_FROM_DDC_PROCESSED(fifo_to_cap_data_processed_w),

								.DATA_FROM_FIFO_TO_RAM(data_from_fifo_to_ram_w[15:0]),

								//.RESERVE_RAM_FOR_WRITING(reserve_ram_for_writing_w),
								.SR_EMPTY_GATED(sr_empty_gated_w),
								.RAM_WRITE_DATA_PROCESSED(w_ram_data_processed),
								.READY_TO_WRITE(w_ready_to_write),

								.DDC_FIFO_WRITE_DATA_AVAILABLE(ddc_fifo_write_data_available_w),
								.RAM_WRITE_DATA_REQUESTED(ram_to_ddc_data_fifo_w)
								//.DDC_FIFO_WRITE_DATA_LOADED(ddc_fifo_write_data_loaded_w)
								);



RAM_CONTROL memory_con(	.FPGA_CLK(FPGA_CLK),
								.FPGA_RESET(FPGA_RESET),

								//
								.DATA_FROM_CAPTURE_FIFO(data_from_fifo_to_ram_w[15:0]),
								.DATA_FROM_RAM(data_from_ram_w[15:0]),
								

								.RAM_ADDR_OUT(RAM_ADDRESS[18:0]),
								//.RAM_DATA(ram_data_internal_bus_w[15:0]),
								.RAM_DATA(RAM_DATA[15:0]),
								//.PUT_DATA_ON_PORT(put_ram_data_on_port_w),

								.nCS1(CSn1),
								.nCS2(CSn2),
								.nOE_PASSTHROUGH(OEn),
								.nWE_PASSTHROUGH(WEn),

								// Communications with DDC_ACQ_CONTROL
								.RESET_ADDRESS_COUNTERS(reset_address_counters_w),

								// Communications with DDC_DATA_FIFO
								.RESERVE_RAM_FOR_WRITING(reserve_ram_for_writing_w),

								.DATA_FROM_DDC_FIFO_AVAILABLE(ddc_fifo_write_data_available_w),	// this is 1'b1 when the DDC_DATA_FIFO shows !empty
								.RAM_WRITE_DATA_REQUESTED(ram_to_ddc_data_fifo_w),  // this is how we say we want the data to be loaded onto DATA_FROM_CAPTURE_FIFO[15:0]
								//.DDC_FIFO_WRITE_DATA_LOADED(ddc_fifo_write_data_loaded_w), // this goes to 1 when data is loaded onto DATA_FROM_CAPTURE_FIFO[15:0]
								.RAM_WRITE_DATA_PROCESSED(w_ram_data_processed),
								.READY_TO_WRITE(w_ready_to_write),

								// Communications with RAM_TO_USB_FIFO
								.DATA_STORED_IN_RAM(data_stored_in_ram_w),
							   .REQUEST_RAM_DATA(request_ram_data_w),
								.DATA_AVAILABLE_FROM_RAM(data_available_from_ram_w)
								);


RAM_TO_USB_FIFO ram_fifo(	.FPGA_CLK(FPGA_CLK),
									.FPGA_RESET(FPGA_RESET),

									.DATA_FROM_RAM(data_from_ram_w[15:0]),
								
									.RAM_RESERVED_FOR_WRITING(reserve_ram_for_writing_w), //this is set when the device is running, storing data to the RAM

									.DATA_STORED_IN_RAM(data_stored_in_ram_w), //this is high when ram address in != ram address out
									.REQUEST_RAM_DATA(request_ram_data_w), // The FIFO sets this when sr_full=0 and when data_stored_in_RAM=1
									.DATA_AVAILABLE_FROM_RAM(data_available_from_ram_w), //DDC_DATA_CAPTURE sets this to 1 when new data is available for latching
									//.DATA_FROM_RAM_PROCESSED(data_from_ram_processed_w),

									.DATA_FROM_FIFO_TO_USB(data_from_fifo_to_usb_w),

									.RAM_FIFO_WRITE_DATA_AVAILABLE(ram_fifo_write_data_available_w),
									.USB_WRITE_DATA_REQUESTED(usb_write_data_requested_w),
									.RAM_FIFO_WRITE_DATA_LOADED(ram_fifo_write_data_loaded_w),
									.USB_WRITE_DATA_PROCESSED(usb_write_data_processed_w),
									
									.PKTEND_INHIBITOR(w_pktend_inhibitor),
								   .PKTEND_SEND(w_send_pktend),
   								.PKTEND_SENT(w_pktend_sent_ack)

									//.latch_out(PE[0]),
									//.fifo_address_out(PE[4:1])
									);






USB_IO usb_interface(	.IF_CLK(IFCLK_I),
								.FPGA_RESET(FPGA_RESET),

								.SLAVE_READ(SLRD_O),
								.SLAVE_WRITE(SLWR_O),
								.SLAVE_OUTPUT_ENABLE(SLOE_O),
								.FIFO_EMPTY_FLAG_C(FLAGC_I),
								.FIFO_FULL_FLAG_B(FLAGB_I),
								.FIFO_ADDRESS(FIFOADR_O),
								.PACKET_END(PKTEND_O),    

								.DATA_FROM_USB_PORT( {pb_i[7:0],pd_i[7:0]} ),
								.DATA_FROM_USB_TO_OPCODE_PROCESSOR(usb_io_to_opcode_processor_3_busw[15:0]),
								.DATA_FROM_DDC(data_for_usbio_write[15:0]),	 //see assign statement
								.DATA_TO_USB_PORT( {pb_o[7:0],pd_o[7:0]} ),

								.USB_READ_DATA_AVAILABLE(usb_io_to_opcode_processor_1_w),
								.READ_DATA_PROCESSED(opcode_processor_to_usb_io_2_w),

								.DDC_DATA_AVAILABLE_FOR_WRITE( ram_fifo_write_data_available_w || opcode_data_available_for_write_w),
		   		 			.USB_WRITE_DATA_REQUESTED_FROM_DDC_FIFO(usb_write_data_requested_w),
								.DDC_DATA_LOADED_FOR_WRITE(ram_fifo_write_data_loaded_w || opcode_data_loaded_w),
								.USB_WRITE_DATA_PROCESSED(usb_write_data_processed_w),
								.PKTEND_INHIBITOR(w_pktend_inhibitor),
								.PKTEND_SENT_ACK(w_pktend_sent_ack),
                		   .SEND_PKTEND(w_send_pktend)

								);








		






endmodule

